#include "ads1115.h"
#include "delay.h"
#include "uart.h"
unsigned int AD_DATA;
#define GAIN 2
float adi=512;
void I2C_Configuration(void)
{
  SCL_OUT;
  SDA_OUT;
}

static int I2C_Start(void)
{       
  SCL_L;
  delay_us(20);
  SDA_H;
  
  SCL_H;                   
  delay_us(20);
  SDA_IN;
  if(!SDA_read)  
  {
     put_char('a');
     return DISABLE;  /* SDAΪ͵ƽ߳,˳ */
  }
  SDA_OUT;
  SDA_L;
  
  SDA_IN;
  if(SDA_read)   
  {
    put_char('b');
    return DISABLE;  /* SDAΪߵƽ߳,˳ */
  }
  SDA_OUT;
  
  SCL_L;	
  SDA_H;
  delay_us(20);
  
  return ENABLE;
}

static int I2C_Stop(void)
{
  SCL_L;
  delay_us(20);
  SDA_L;
  SCL_H;                  
  delay_us(20);
  SDA_IN;	
  if(SDA_read) return DISABLE;  /* SDAΪߵƽ߳,˳ */
  SDA_OUT;
  
  SDA_H;
  SDA_IN; 
  
  if(!SDA_read)   return DISABLE; /* SDAΪ͵ƽ߳,˳ */
  SDA_OUT;
  SCL_L;
  SDA_H;	
  delay_us(20);
  
  return ENABLE;
}

static void I2C_Ack(void)
{	
  SCL_L;
  SDA_L;
  delay_us(20);
  SCL_H;
  delay_us(20);
  SCL_L;
  SDA_H;
  delay_us(20);
}

static void I2C_NoAck(void)
{	
  SCL_L;
  SDA_H;
  delay_us(20);
  SCL_H;
  delay_us(20);
  SCL_L;
  delay_us(20);
}

/*Ϊ:=1ACK,=0ACK*/
static int I2C_WaitAck(void) 	
{
  SCL_L;
  SDA_H;			
  delay_us(20);
  SCL_H;
  
  SDA_IN;
  delay_us(20);
  if(SDA_read)
  {
    SCL_L;
    SDA_OUT;
    return DISABLE;
  }
  delay_us(20);
  SDA_OUT;
  
  return ENABLE;
}

/*ݴӸλλ*/
static void I2C_SendByte(unsigned char SendByte) 
{
  unsigned char i=8;
  while(i--)
  {
    SCL_L;
    delay_us(20);
    
    if(SendByte&0x80)
      SDA_H;  
    else 
      SDA_L; 
    
    SendByte<<=1;
    delay_us(20);
    SCL_H;
    delay_us(20);
  }
  SCL_L;
  SDA_H;
}


/*ݴӸλλ*/
static int I2C_ReceiveByte(void)  
{ 
  unsigned char i=8;
  unsigned char ReceiveByte=0;
  
  SDA_H;
  delay_us(20);
  SDA_IN;
  delay_us(20);
  while(i--)
  {
    ReceiveByte<<=1;      
    SCL_L;
    delay_us(20);
    SCL_H;
    delay_us(20);
  
    if(SDA_read)
    {
      ReceiveByte|=0x01;
    }
  }
  SDA_OUT;
  delay_us(20);
  SCL_L;
  
  return ReceiveByte;
}

/*дһֽݣʱοPDF 22ҳΪ:=1ɹд,=0ʧ*/           
unsigned char Write_Confreg(unsigned char SendByteH, unsigned char SendByteL)
{		
  if(!I2C_Start())
  {
    return DISABLE;
  }
  
  I2C_SendByte(ADS1115_WR); /*дĵַ */
  
  if(!I2C_WaitAck())
  {
    I2C_Stop(); 
    return DISABLE;
  }
  
  I2C_SendByte(ADS1115_CR); /*ѡüĴ*/ 
  
  if( !I2C_WaitAck())
  {
    I2C_Stop(); 
    return DISABLE;
  }
  
  I2C_SendByte(SendByteH);
  
  if( !I2C_WaitAck())
  {
    I2C_Stop(); 
    return DISABLE;
  }
  
  I2C_SendByte(SendByteL);
  
  if( !I2C_WaitAck())
  {
    I2C_Stop(); 
    return DISABLE;
  }  
  
  I2C_Stop(); 
  
  return ENABLE;
}	

/*ȡADCֵ---pBuffer: ŶݣΪ:=1ɹ,=0ʧ*/ 
unsigned char Read_ConvValue(unsigned int *pBuffer)
{	
  unsigned char temp1=0,temp2=0;
  if(!I2C_Start())
  {
    return DISABLE;
  }
  
  I2C_SendByte(ADS1115_WR); /*дĵַ */    
  
  if( !I2C_WaitAck() )
  {
    I2C_Stop(); 
    return DISABLE;
  }
  
  I2C_SendByte(ADS1115_CV); /*ĴѡתĴ*/   
  
  if( !I2C_WaitAck() )
  {
    I2C_Stop(); 
    return DISABLE;
  }	
  
  I2C_Stop();
  
  if(!I2C_Start())
  {
    return DISABLE;
  }
  
  I2C_SendByte( ADS1115_RD ); /*ĵַ */
  
  if( !I2C_WaitAck() )
  {
    I2C_Stop(); 
    return DISABLE;
  }
  
  temp1= I2C_ReceiveByte();
  I2C_Ack(); 
  temp2= I2C_ReceiveByte();
  I2C_Ack();
  
  I2C_Stop(); 
  *pBuffer=((unsigned int)temp1<<8)|temp2;
  
  return ENABLE;
}

////////////////////////////////////////////
float ads1115_read(unsigned char ch)
{
  unsigned int pBuffer;
  float ads1115_v;
  //0xC0->6.144V(1)       0xc2->4.096V(1)
  //0xc4->2.048V          0xc6->1.024V
  if(Write_Confreg(0xC3+(0x10*ch),0x83))
  {
    if(Read_ConvValue(&pBuffer))//תͨpBuffer
    {
     // pBuffer= sum1;
      
      if(pBuffer>32767) 
      {
        pBuffer=65535-pBuffer;
        put_char('-');
      }
      else 
      {
        ads1115_v=(float)pBuffer*4.096/32768;
        put_char('+');
      }
    }
  }
  else
  {
    put_string("Failed......");
  }
    
  return ads1115_v; 
}
//////////////////////////////////////////////////

unsigned int ads1115_conv(unsigned char ch)  //chΪͨתʱͨ
{
  unsigned int tmp;
  
  if(Write_Confreg(CR_MSB+(0x10*ch),0x83))
  {
    if(Read_ConvValue(&tmp))//תͨpBuffer
    {
      AD_DATA=tmp;
      if(tmp>32767) //16bitλΪλ1= 0= 
        tmp=65535-tmp;
      else
        tmp=tmp;
      put_float(tmp,0);
    }
  }
  return tmp; 
}
  //////////ֵ˲//////////
#define SAMPLE_N 3
float ads1115_read_fil(unsigned char ch)
{
    unsigned int value_buf[SAMPLE_N],temp,mid_value;
    unsigned char count,i,j;
    float ads1115_v=0;

     for(count=0;count<SAMPLE_N;count++)
        value_buf[count]=ads1115_conv(ch);//洢ֵ 
    for(j=0;j<SAMPLE_N;j++)//ֵ
    {
        for(i=0;i<SAMPLE_N-j-1;i++)
        {
            if(value_buf[i]>value_buf[i+1])
            {
                temp = value_buf[i];
                value_buf[i]=value_buf[i+1];
                value_buf[i+1] = temp;
            }
        }
    }
    mid_value=value_buf[(SAMPLE_N-1)/2];
    ads1115_v=(float)(mid_value)*GAIN*(4.096/65535); //׼ѹΪ4.096 
   
    return ads1115_v;
}
